	  
	  // fork getUserMedia for multiple browser versions, for the future
	// when more browsers support MediaRecorder

	navigator.getUserMedia = ( navigator.getUserMedia ||
						   navigator.webkitGetUserMedia ||
						   navigator.mozGetUserMedia ||
						   navigator.msGetUserMedia);

	// set up basic variables for app

	var record = document.querySelector('.record');
	var stop = document.querySelector('.stop');
	var clipContainer = document.querySelector('.clipContainer');
	var canvas = document.querySelector('.visualizer');
	var clipLabel = document.querySelector('.clipLabel');
	var audio;
	var audioRecordingSupported = false;
	var mediaRecorder;
	
	UDUTU_API.gblNextButton.btnEnabled(true);


	//main block for doing the audio recording

	if (navigator.getUserMedia) {
	   console.log('getUserMedia supported.');
	   navigator.getUserMedia (
		  // constraints - only audio needed for this app
		  {
			 audio: true
		  },

		  // Success callback
		  function(stream) {
			 audioRecordingSupported = true;
			 audioStream = stream;
			 mediaRecorder = new MediaRecorder(audioStream);
			 
			 audio = document.querySelector('.audio');
			 mediaRecorder.ondataavailable = function(e) {
				console.log("data available");
				var audioURL = window.URL.createObjectURL(e.data);
				audio.src = audioURL;
			 }
		  },

		  // Error callback
		  function(err) {
			  audioRecordingSupported = false;
			 console.log('The following gUM error occured: ' + err);
		  }
	   );
	} else {
	   console.log('getUserMedia not supported on your browser!');
	}
	
	function startRecording()
	{
		
		mediaRecorder.start();
		console.log(mediaRecorder.state);
		console.log("recorder started");
		$('.stop').removeClass("hidden");
		$('.record').addClass("hidden");
	}
	function stopRecording()
	{
		mediaRecorder.stop();
		console.log(mediaRecorder.state);
		console.log("recorder stopped");
		$('.stop').addClass("hidden");
		$('.record').removeClass("hidden");
	}
